<?php
/*
Plugin Name: myGallery
Plugin URI: http://www.wildbits.de/mygallery/
Description: Yet another gallery. Who is next?
Author: Thomas Boley
Version: 1.5.1

Author URI: http://www.wildbits.de


Copyright 2010  Thomas Boley  (email : tboley@web.de)

Use at your own risk. No warranty expressed or implied is provided.
*/ 

//#################################################################

define('myGalleryPath',dirname(__FILE__).'/');
define('myGalleryURL',get_bloginfo('wpurl').'/wp-content/plugins/mygallery/');

// read-write permissions for directorys and files

define('file_permissions',0666);
define('directory_permissions',0777);


@include_once(myGalleryPath. 'myfunctions/mygalleryfunctions.php');

if (!function_exists('getmygallerys')) {
	_e('Function library mygalleryfunctions.php was not found.', 'myGallery');
	die;
}


//#################################################################

function mygallery ($content) {
	
	global $table_prefix, $wpdb,$wp_rewrite, $myurl, $mg_options,$mynavigation_obj;
	
	if (!$mynavigation_obj)  $mynavigation_obj= new navigation_obj($_GET['galpage'],$_GET['gallery'],$_GET['thumbpage'],$_GET['picture_id']);
	
	// load language
	
	if ($mg_options[language]) load_textdomain('myGallery', myGalleryPath.'/languages/'.$mg_options[language].'.mo');
	
	// used variables 
	
	$mg_options = get_option('mygalleryoptions');
	$mg_exifoptions= get_option('mygexifoptions');
	
	$myurl=get_bloginfo('wpurl').'/'.$mg_options[gallerybasepath];
	
	$search = "/\[mygal=([A-Za-z0-9\-\_]+)(|\([0-9\,]+\))\]/";
	
	if ($mg_options[picinsteadthumbs] AND !$mynavigation_obj->picture_id) {
		
		if (preg_match($search, $content,$matches)) {
			$tmp_result=getfirstgallerypicture($matches[1],$matches[2]); 
			$mynavigation_obj->picture_id=$tmp_result->id;
		}
	}
	
	if ($mynavigation_obj->picture_id) {
		
		if (preg_match($search, $content,$matches)){
			$result=getpicture($mynavigation_obj->picture_id);
			
			// exit if there is no pictures with this id
			
			if (!$result) {
				return;	
			}
			
			$search = "/\[mygal=".$result->name."(|\([0-9\,]+\))]/";
			$replace = "[mybigpic][mygal=".$result->name."$1]";
			$content = preg_replace ($search, $replace, $content);
			// show thumbs under bgc picture
			
			if ($mg_options[bigpicshowthumbs])  {
				$content=conv_tag($content); 
			}
			else {
				$search = "/\[mygal=([A-Za-z0-9\-\_]+)(|\([0-9\,]+\))\]/";
				$replace='';
				$content = preg_replace ($search, $replace, $content);	
			}
			
			// create HTML for big picture
			
			$search = "/\[mybigpic\]/";
			$replace=createhtmlforbigpicture($result,$mynavigation_obj->picture_id,$matches[2]);
			
			$content = preg_replace ($search, $replace, $content);
			
		}	
	}
	
	else {
		
		// if there is no gallery_id match, function returns a empty page
		
		$content=conv_tag($content);
	}
	
	return $content;
}


//#################################################################

// reads all mygallery-tags an replaces the tags with content

function conv_tag($mystring) {
	
	// single gallery
	
	$search = "/\[mygal=([A-Za-z0-9\-\_]+)(|\([0-9\,]+\))\]/";
	$mg_options=get_option('mygalleryoptions');
	
	global $myurl; 
	
	if (preg_match($search, $mystring)){
		
		preg_match_all($search, $mystring, $temp_array);
		if (is_array ($temp_array[1])) {
			foreach ($temp_array[1] as $key=>$v0) {
				$search = "/\[mygal=".$v0.addcslashes ($temp_array[2][$key],'\(\)')."\]/";
				$replace= showtumbs($v0,0,$temp_array[2][$key]);
				$mystring= preg_replace ($search, $replace, $mystring);
			}
			
		}
	}
	
	// gallery overview
	
	$search = "/\[mygallistgal\]/";
	
	if (preg_match($search, $mystring)){
		
		if (preg_match($search, $mystring)){
			$replace=gallistgal();
			$search = "/\[mygallistgal\]/";
			$mystring= preg_replace ($search, $replace, $mystring);
		}
		
	}
	
	// inline gallery
	
	$search = "/\[myginpage=([A-Za-z0-9\-\_]+)(|\([0-9\,]+\))\]/";
	
	if (preg_match($search, $mystring)){
		
		preg_match_all($search, $mystring, $temp_array);
		
		if (is_array($temp_array[1])) {
			foreach ($temp_array[1] as $v0) {
				$search = "/\[myginpage=".$v0."\]/";
				$replace=showtumbs($v0,1);
				$mystring= preg_replace ($search, $replace, $mystring);
			}
			
		}
	}
	
	// single picture
	
	$search = "/\[inspic=(\d+)(|,\w+|,)(|,http:\/\/[^,]+|,fullscreen|,gal|,)(|,thumb|,\d+|,)(|,:\w+)\]/";
	
	if (preg_match($search, $mystring,$sresult)){
		
		preg_match_all($search, $mystring, $temp_array);
		
		if (is_array($temp_array)) {
			foreach ($temp_array[1] as $key =>$v0) {
				$search = "/\[inspic=".$v0.$temp_array[2][$key].addcslashes($temp_array[3][$key],'\/').$temp_array[4][$key].$temp_array[5][$key]."\]/";
				$replace=myinlinepicture($v0,$temp_array[2][$key],$temp_array[3][$key],$temp_array[4][$key],$temp_array[5][$key]);
				$mystring= preg_replace ($search, $replace, $mystring);
			}	
		}
	}
	
	// picture link
	
	$search = "/\[mypicref=(\d+)\](.*)\[\/mypicref\]/U";	
	
	if (preg_match($search, $mystring)){
		
		preg_match_all($search, $mystring, $temp_array);
		
		if (is_array($temp_array[1])) {
			foreach ($temp_array[1] as $key => $v0) {
				$search = "/\[mypicref=".$v0."\](.*)\[\/mypicref\]/U";	
				$replace=mytextpiclink($v0,$temp_array[2][$key]);
				$mystring= preg_replace ($search, $replace, $mystring);
			}	
		}
	}
	
	$mystring=" \t".$mystring;
	return $mystring;
}
//#################################################################

// adminpanel functions

function mygallery_menu() {
	if (function_exists('add_menu_page')) {
		
		add_menu_page('mygallery Generator', 'myGallery','use myGallery',dirname(__FILE__).'/myfunctions/mygallerymain.php');	
		
	}
	
	if (function_exists('add_submenu_page')) {
		$mg_options=get_option('mygalleryoptions');
		
		if ($mg_options[language]) load_textdomain('myGallery', myGalleryPath.'/languages/'.$mg_options[language].'.mo');
		add_submenu_page( dirname(__FILE__).'/myfunctions/mygallerymain.php', __('Gallery Management', 'myGallery'), __('Gallery Management', 'myGallery'), 'use myGallery',dirname(__FILE__).'/myfunctions/mygalleryadmin.php');
		add_submenu_page( dirname(__FILE__).'/myfunctions/mygallerymain.php', __('Options', 'myGallery'), __('Options', 'myGallery'), 'myGallery Settings',dirname(__FILE__).'/myfunctions/mygalleryoptions.php');
		add_submenu_page( dirname(__FILE__).'/myfunctions/mygallerymain.php', __('Gallery Style', 'myGallery'),__('Gallery Style', 'myGallery'), 'myGallery Settings',dirname(__FILE__).'/myfunctions/mygallerystyle.php');
		add_submenu_page( dirname(__FILE__).'/myfunctions/mygallerymain.php', __('Exif Settings', 'myGallery'), __('Exif Settings', 'myGallery'), 'myGallery Settings',dirname(__FILE__).'/myfunctions/mygalleryexif.php');
		add_submenu_page( dirname(__FILE__).'/myfunctions/mygallerymain.php', __('Info', 'myGallery'), __('Info', 'myGallery'), 'use myGallery',dirname(__FILE__).'/myfunctions/mygallinfo.php');
		
	}
}

//#################################################################

function myrandompic($myamount=1) {
	
	global $table_prefix, $wpdb,$wp_rewrite,$mg_options;
	
	// used variables 
	
	$mybaseurl=get_bloginfo('wpurl');
	$mg_options=get_option('mygalleryoptions');
	$myurl=$mybaseurl.'/'.$mg_options[gallerybasepath];
	
	// read pictures table into array
	
	$mg_options=get_option('mygalleryoptions');
	
	
	if ($mg_options[excludeoverview]) {
		$mypicturesarray = $wpdb->get_results('SELECT '.$table_prefix.'mypictures.id FROM '.$table_prefix.'mypictures, '.$table_prefix.'mygallery, '.$table_prefix.'mygprelation WHERE ' .$table_prefix.'mypictures.id = '.$table_prefix. 'mygprelation.pid AND '.$table_prefix.'mygprelation.gid = '.$table_prefix.'mygallery.id AND ('.$table_prefix.'mygallery.excludegal IS NULL OR '.$table_prefix.'mygallery.excludegal=0 ) AND ('.$table_prefix.'mypictures.picexclude IS NULL OR '.$table_prefix.'mypictures.picexclude=0)');
		
	}
	
	else {
		
		$mypicturesarray = $wpdb->get_results('SELECT id FROM '.$table_prefix.'mypictures WHERE '.$table_prefix.'mypictures.picexclude IS NULL OR '.$table_prefix.'mypictures.picexclude=0');
	}
	
	// exit if no gallery pictures are found
	
	if (!$mypicturesarray) {
		return;	
	}
	// get random element(s)
	
	for ($i =1; $i<=$myamount; $i++){
		srand();
		$myrandomid=$mypicturesarray[ array_rand ($mypicturesarray)]->id;
		
		// read element infos
		
		$result=$wpdb->get_row('SELECT * FROM '.$table_prefix.'mypictures,'.$table_prefix.'mygprelation,'.$table_prefix.'mygallery WHERE '.$table_prefix.'mypictures.id = '.$myrandomid.' AND '.$table_prefix.'mygprelation.pid = '.$myrandomid.' AND '.$table_prefix.'mygallery.id ='.$table_prefix.'mygprelation.gid' );
		
		$mypage_id=$wpdb->get_var('SELECT pageid FROM '.$table_prefix.'mygallery WHERE id ='.$result->gid);
		
		
		// return picture
		
		if ($mg_options[templatemode] AND (!$mypage_id)) $mypage_id=$mg_options[templatemodeid];
		
		if  ($mg_options[randombox]) {
			$myhyperlink_open='<a rel="lightbox" href="'.$myurl.$result->name.'/'.$result->picturepath.'">';
			$myhyperlink_close='</a>';
			
		}
		
		else if ($mypage_id) {
			
			$myreference=get_permalink($mypage_id);
			
			if ( $wp_rewrite->using_permalinks() ) {
				$myreference=$myreference.'?picture_id=';
			}
			else {
				$myreference=$myreference.'&amp;picture_id=';
			}
			
			
			$myhyperlink_open='<a href="'.$myreference.$result->pid.'">';
			$myhyperlink_close='</a>';
		}
		
		$thumb_size=getimagesize(ABSPATH.$mg_options[gallerybasepath].$result->name.'/tumbs/tmb_'.$result->picturepath);
		
		$mypicstring=$mypicstring.'<div class="myrandompic">'.$myhyperlink_open.'<img src="'.$myurl.$result->name.'/tumbs/tmb_'.$result->picturepath.'" alt="'.$result->alttitle.'" title="'.$result->alttitle.'" width="'.$thumb_size[0].'" height="'.$thumb_size[1].'" />'.$myhyperlink_close.'</div>';
	}
	
	
	echo $mypicstring;// maybe not the best way to show the result
	
}

//#################################################################

function myGalleryJScript() {
	
	global $mg_options;
	
	$myscript = '<script type="text/javascript">'."
	function changePicture(img, galid,myalt,mywidth,myheight,myftid) {
		document.getElementById(galid).setAttribute('src',img);
		document.getElementById(galid).setAttribute('alt',myalt);
		document.getElementById(galid).setAttribute('title',myalt);";
		if ($mg_options[igsafewh]) {
			$myscript =$myscript."document.getElementById(galid).setAttribute('width',mywidth);
			document.getElementById(galid).setAttribute('height',myheight);";
		}
		if ($mg_options[simplescale]) {
			$myscript =$myscript."bigid='b'+galid;
			document.getElementById(bigid).setAttribute('href',img);";
		}
		if ($mg_options[igpicdes]) {
			$myscript =$myscript."
			var footerid=galid+'ft';
			var nottransparent=true;
			try {
				var nodcontent=document.getElementById(myftid).firstChild.nodeValue;
			}
			catch(err) {
				nodcontent='.'
				document.getElementById(footerid).setAttribute('class','transparent');
				nottransparent=false;
				
			}
			if (nottransparent) {
				document.getElementById(footerid).setAttribute('class','nottransparent');
			}
			document.getElementById(footerid).firstChild.nodeValue=nodcontent;
			";
		}
		$myscript =$myscript."
	}
	</script>";
	echo $myscript;
	
}

//#################################################################

function myGalleryStyle() {
	
	global $mg_options;
	
	$mystyle="\n".'<link rel="stylesheet" href="'.get_bloginfo('wpurl').'/wp-content/plugins/mygallery/css/'.$mg_options[stylefile].'" type="text/css" media="screen" />'."\n"; 
	echo $mystyle;
	
	}
//#################################################################

function includeLightboxJS() {
	
	global $mg_options;
	
	if ($mg_options[lightboxversion]==2) {
		@include_once(myGalleryPath. 'myfunctions/mylbx2_inc.php');
	}
	
	else {
		@include_once(myGalleryPath. 'myfunctions/mylbx_inc.php');
	}
	
	echo $myscript;
}
//#################################################################
function my_button_init() {
	
	// used to insert button in wordpress 2.x editor
	
	$button_image_url = buttonsnap_dirname(__FILE__) . '/images/mgbrowser.gif';
	
	buttonsnap_jsbutton($button_image_url, 'myGallery Browser', 'window.open("'.myGalleryURL.'myfunctions/mygallerybrowser.php?myPath='.ABSPATH.'", "myGalleryBrowser",  "width=780,height=600,scrollbars=yes");');
}

//#################################################################

// init mygallery tables in wp-database if plugin is activated

if (isset($_GET['activate']) && $_GET['activate'] == 'true') {
	
	require_once(ABSPATH . 'wp-content/plugins/mygallery/myfunctions/mygalleryinstall.php');
	add_action('init', 'mygallery_install');
}

// adding functions to wordpress

add_filter('the_content', 'mygallery',9); 
add_filter('the_excerpt', 'mygallery',9); 

//add_filter('the_content', 'nasty_p_filter'); 

add_action('admin_menu', 'mygallery_menu');

// add JavaScript to header

add_action('wp_head', 'myGalleryJScript');

// add Stlye to header

$mg_options=get_option('mygalleryoptions');

if ($mg_options[includestyle]) add_action('wp_head', 'myGalleryStyle');

// add Lightbox JS to header

if (($mg_options[lightboxjs]) OR ($mg_options[gallerybox]) OR ($mg_options[randombox])) add_action('wp_head', 'includeLightboxJS');

// add gallerybrowser for posts

list ($mversion,$sversion,$pversion) = split("\.", get_bloginfo('version')); 

if ($sversion<1) {
	@include_once(myGalleryPath.'myfunctions/buttonsnap.php');	
	add_action('init', 'my_button_init');	
}
else {
	
	
	
	// code from TinyMCE external plugin example: http://an-archos.com/anarchy-media-player#download
	// many thanks tofor the code!
	
	function mygallery_mce_plugins($plugins) {    
		array_push($plugins, "-mygallerytinymce", "bold");    
		return $plugins;
	}
	
	function mygallery_mce_buttons($buttons) {
		array_push($buttons, "separator", "mygallerytinymce");
		return $buttons;
	}
	
	
	function mygallery_external_plugins() {	
		echo 'tinyMCE.loadPlugin("mygallerytinymce","' . myGalleryURL . '/mygallerytinymce/");' . "\n"; 
		return;
	}
	add_filter("mce_plugins", "mygallery_mce_plugins", 5);
	add_filter("mce_buttons", "mygallery_mce_buttons", 5);
	add_action('tinymce_before_init','mygallery_external_plugins');
	//add_action('admin_head','mytinyJS');
	
}


function mytinyJS() {
	$myscript = '<script type="text/javascript">
	   
	function openmybrowser() {
		window.open("'.myGalleryURL.'myfunctions/mygallerybrowser.php?myPath='.ABSPATH.'", "myGalleryBrowser",  "width=700,height=600,scrollbars=yes");
	}
	
	jQuery(document).ready(function() {
        content = \'<input id="myGalleryBrowser" class="ed_button" type="button" value="myGalleryBrowser" title="open myGallery Browser" onclick="openmybrowser();" />\';

        jQuery("#ed_toolbar").append(content);
    });
	
		</script>';
echo $myscript;
	
}
	add_action('admin_head','mytinyJS');

?>